N=1024; 
para = {'position', [100, 100, 2000, 1500], 'unit', 'pixel'};
retFolder = '/sandbox/Dropbox/smallWorlds/20160809_Bacterial_Confocal_PSFs';
psf = tif.read('/sandbox/smallWorlds/20160809_Bacterial_Confocal_PSFs/PSF_Ave.tif');
%%
for n = [200,202, 211]%[151, 201, 251]
    I = double(psf(:,:,n)); 
    figure(n); clf; set(gcf, para{:});
    plot(sum(I,1)/N, 'rx-'); hold on; plot(sum(I,2)/N, 'b+-');
    legend('DU along: x', 'DU along: y');    
    grid on; grid minor;
    myTitle = sprintf('AnalyzeIntensity psfAve z=%d', n);
    title(myTitle);
    printfig(fullfile(retFolder, [myTitle '.png']), [], 'cleanTitle', false);
end
%%
camOffSet = tif.read('/sandbox/Dropbox/smallWorlds/20170314_Camera/camOffset.tif');
I = double(camOffSet); 
figure(11); clf;  set(gcf, para{:});
plot(sum(I,1)/N, 'rx-'); hold on; plot(sum(I,2)/N, 'b+-');
legend('DU along: x', 'DU along: y');
grid on; grid minor;
myTitle = 'AnalyzeIntensity camOffSet';
title(myTitle);
printfig(fullfile(retFolder, [myTitle '.png']), [], 'cleanTitle', false);
%%
floodedImage = tif.read('/sandbox/smallWorlds/20160809_Bacterial_Confocal_PSFs/flooded_iris_100slope.tif');
I = double(floodedImage(:,:,end));
figure(12); clf;  set(gcf, para{:});
plot(sum(I,1)/N, 'rx-'); hold on; plot(sum(I,2)/N, 'b+-');
legend('DU along: x', 'DU along: y');
grid on; grid minor;
myTitle = 'AnalyzeIntensity floodedImage';
title(myTitle);
printfig(fullfile(retFolder, [myTitle '.png']), [], 'cleanTitle', false);


%%
I = double(tiles.maskEdgeFlooded) + double(tiles.maskEdgeOuterRect) + double(tiles.maskEdgeInnerRect);
figure(13); clf;  set(gcf, para{:});
plot(sum(I,1)/N, 'rx-'); hold on; plot(sum(I,2)/N, 'b+-');
legend('DU along: x', 'DU along: y');
grid on; grid minor;
myTitle = 'AnalyzeIntensity tiles mask';
title(myTitle);
printfig(fullfile(retFolder, [myTitle '.png']), [], 'cleanTitle', false);

