%% Preprocess PSF
folder = '/sandbox/smallWorlds/20160809_Bacterial_Confocal_PSFs/';
%maskObjFile = fullfile(folder, 'PSF_Ave_maskObj_Central100Slices.bmp');
%maskObjFile = fullfile(folder, 'PSF_Ave_maskObj3D_151to251.tif');
maskObjFile = fullfile(folder, 'PSF_Ave_maskBg3D_151to251useful.tif');
imgNameAll = {'PSF_1', 'PSF_2', 'PSF_3', 'PSF_4', 'PSF_Ave'};
pages = 151:251;
EMGain = 750;
croppedDepthSz = 101;
halfSz = floor(croppedDepthSz/2); % 50
          
for n = 1:numel(imgNameAll)
    imgName = imgNameAll{n};
    imgFile = fullfile(folder, [imgName, '.tif']);    
    preprocess.cleanBackground(imgFile, maskObjFile, EMGain); %cleanBackground(imgFile, maskObjFile, EMGain, pages, r, isOutlierLargeArea)        
    % show cropped depths
    preprocess.showPhotonPerFrame(imgFile, maskObjFile, EMGain, pages);
    printfig(fullfile(folder, sprintf('summary_Central%dPages_%s.png', numel(pages), imgName)), [], 'cleanTitle', false);
    % show all depths
    preprocess.showPhotonPerFrame(imgFile, maskObjFile, EMGain); 
    printfig(fullfile(folder, sprintf('summary_AllPagesOnlyCentral%dGood_%s_.png',  numel(pages), imgName)), [], 'cleanTitle', false);

end


%% Preprocess Bacterium
folder = '/sandbox/Dropbox/smallWorlds/20160809_Bacterial_Confocal_PSFs';
maskNameAll = {'Bacteria1_DoubleLobes_MFM_10Measures_Mean_maskObj', 'Bacteria2_LongZ_MFM_10Measures_Mean_Mask'};
imgNameAll = {'Bacteria1_DoubleLobes_MFM_10MeasuresAndMean',  'Bacteria2_LongZ_MFM_10MeasuresAndMean'};
EMGain = 300;

for n = 1:numel(imgNameAll)
    imgName = imgNameAll{n};
    maskObjName = maskNameAll{n};    
    imgFile = fullfile(folder, [imgName, '.tif']);    
    maskObjFile = fullfile(folder, [maskObjName, '.bmp']);
    
    preprocess.cleanBackground(imgFile, maskObjFile, EMGain);
    preprocess.showPhotonPerFrame(imgFile, maskObjFile, EMGain);
    printfig(fullfile(folder, sprintf('%s_summary.png',  imgName)), [], 'cleanTitle', false);
end