%% 20180516 data
%preprocess.removeOutsideTile.m:  if the tiles are aligned, then preprocess the PSF and sample (and maybe floodedImage', so that we only keep pixels inside tiles

folder = '/sandbox/smallWorlds/20180516_Peri_PSF_MFM3x3_Confocal';
tifFileNameAll = {'PSF_f201_PhU_GsStd1.84', ...                    
                    'peri_1_PhU_GsStd0.27_wSum', ...
                    'floodedIris_MFM_f100', ...
                    'floodedIris_MFM_f100_sum'};
pages = [];
maskTiles = imread(fullfile(folder, 'MFM_maskTiles.bmp'));

tifSuffix = '_fs';

for nFile = 1:numel(tifFileNameAll)
    tifFileName = tifFileNameAll{nFile};
    removeGutterFun(folder, tifFileName, pages, tifSuffix, maskTiles)
end


%%
function removeGutterFun(folder, tifFileName, pages, tifSuffix, maskTiles)        
    tifFile = fullfile(folder, [tifFileName, '.tif']);
    imgAll = tif.read(tifFile, pages);    
        
    height = max(sum(maskTiles, 1));
    width = max(sum(maskTiles, 2));
    
    fprintf('Crop tifFile %s (%d pages), only keep pixels inside tiles. Original image size %d x %d, cropped image size %d x %d.\n', ...
            tifFileName, size(imgAll,3), size(imgAll,1), size(imgAll,2), height, width); 
        
    maskTiles = repmat(maskTiles, [1,1,size(imgAll,3)]);
    imgAllInTile = imgAll(maskTiles);
    imgAllInTile = reshape(imgAllInTile, [height, width, size(imgAll,3)]);
            
    tifInTileFile = fullfile(folder, [tifFileName, tifSuffix '.tif']);
    tif.write(imgAllInTile, tifInTileFile);
    
        
end