function fGT = generateShape(shapeChoice, fSz, gap)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

if ~exist('shapeChoice', 'var') || isempty(shapeChoice)
    shapeChoice = 'confocal'; % Choose from 'cubic', 'sphere', 'cylinder', 'confocal'
end

if ~exist('gap', 'var') || isempty(gap)
    gap = 1;
end

fc = floor((fSz+1)/2);
switch lower(shapeChoice)
    case 'cubic'
        % I: cubic shape of (2*winSz+1)^3, at the center shifted by beadShift space
        beadShift = 0; %beadShift = round([-78.3, -86.6, 121-119]); % bead shifted from the center to [y, x, z]
        beadPos = fc + beadShift;
        winSz = 10; % bead as a cube of size (2*winSz+1), if winSz=20, pixelSz = 100nm, then cube of about 4um
        fGT = zeros(fSz);
        fGT(beadPos(1)+(-winSz:winSz), beadPos(2)+(-winSz:winSz), beadPos(3)+(-winSz:winSz))= 1;
    case 'sphere'
        % II: Sphere shape of pi*4/3*radius^3, at the center of object space
        radius = 10;
        fGT = shape.generateSphere(fSz, radius);
    case 'cylinder'
        % III: cylinder shape of pi*radius*radius*cLen, at the center of object space
        radius = 8; cLen = 60;
        fGT = shape.generateCylinder(fSz, radius,cLen, 'z'); % 'y'
    case lower('twopointsZ')
        fGT = zeros(fSz);
        fGT(fc(1), fc(2), fc(3)-floor(gap/2)) = 1;
        fGT(fc(1), fc(2), fc(3)+ceil(gap/2)) = 1;
    case lower('twopointsX')
        fGT = zeros(fSz);
        fGT(fc(1), fc(2)-floor(gap/2), fc(3)) = 1;
        fGT(fc(1), fc(2)+ceil(gap/2),  fc(3)) = 1;        
    otherwise
        error('unkown shape');
        %                     % assume it is a filename
        %                     fGTstruct = load(shapeChoice);
        %                     fGTfields = fieldnames(fGTstruct);
        %                     fGT0 = getfield(fGTstruct,fGTfields{1});
        %                     targetsize = min([size(fGT0);fSz]);
        %                     LL = floor((size(fGT0)-targetsize)/2);
        %                     UR = LL + targetsize - 1;
        %                     fGT = fGT0(LL(1):UR(1),LL(2):UR(2),LL(3):UR(3));
        %                     clear('fGTstruct','fGTfields','fGT0','targetsize','LL','UR');
end
end
