function sphere = generateSphere(sphereSz, diameter)
%%
if ~exist('sphereSz', 'var') || isempty(sphereSz)
    sphereSz = ones(1,3)*ceil(diameter);
end
radius = round(diameter)/2;
sphere = zeros(sphereSz);
fCenter = floor((sphereSz+1)/2);
[xx, yy] = meshgrid(1:sphereSz(2), 1:sphereSz(1)); %[xx, yy] = meshgrid(1:xmax, 1:ymax);
for z = max(1, fCenter(3)-radius):min(sphereSz(3), fCenter(3)+radius)
    mask = ((xx-fCenter(2)).^2 + (yy-fCenter(1)).^2) <= radius.^2 - (z-fCenter(3)).^2;
    sphere(:,:,z) = mask;
end

end
