function display(S)
%struct.display() Recursive routine for displaying nested structs

fields = fieldnames(S);

c = {};nestedStructures = {};
for i = 1:length(fields)
    field = fields{i};
    data = getfield(S,field);
    if ~isstruct(data)
        c{end+1} = field;
        c{end+1} = data;
    else
        nestedStructures{end+1} = struct(field,data);
    end
end

% c contains the elements that aren't structs
% use them to create a new struct, and display it with
% the builtin routine.
if ~isempty(c)
    dispStruct = struct(c{:});
    builtin('disp',dispStruct)
end

% Now loop over the nested structures, recursively passing
% them to this routine.
for i = 1:length(nestedStructures)
    field = fieldnames(nestedStructures{i});
    disp([blanks(4) field{1} '-->'])
    display(getfield(nestedStructures{i},field{1}))
end

end