readme = 'cleanBackgroundUseTiles_Script and cleanBackgroundUseTiles: Masked by tile, Removed Non Uniform Cam Offset, normalized by gain, then each tile subtract constant background from mean of furthest 1000 pixels to center';

folder = '/sandbox/Dropbox/smallWorlds/20160809_Bacterial_Confocal_PSFs';
load(fullfile(folder, 'tiles.mat')); 

% load structure tiles with fields:
%       maskEdgeFlooded: [1024×1024 logical]
%           maskFlooded: [1024×1024 logical]
%           centroidXYs: [2×25 double]
%     outerRectPosXYWHs: [4×25 double]
%     innerRectPosXYWHs: [4×25 double]
%         maskOuterRect: [1024×1024 logical]
%         maskInnerRect: [1024×1024 logical]
%     maskEdgeOuterRect: [1024×1024 logical]
%     maskEdgeInnerRect: [1024×1024 logical]

%% psf
psfOrigUint16 = tif.read(fullfile(folder, 'PSF_Ave.tif'));
tag = 'psfAve';
cam = CAMERA('EMGain', 750, 'camOffsetFile', '/sandbox/Dropbox/smallWorlds/20170314_Camera/camOffset.tif');
pages = 151:251; 
[psf, psfTilePhoton] = preprocess.cleanBackgroundUseTiles(psfOrigUint16, tiles, cam, pages, folder, tag);
save(fullfile(folder, 'psf_Ave_20171218.mat'), 'readme', 'psf', 'psfTilePhoton', 'tiles', 'cam', 'pages');

%% bacteria
bacFileAll = {
    fullfile(folder, 'Bacteria1_DoubleLobes_MFM_10MeasuresAndMean.tif');
    fullfile(folder, 'Bacteria2_LongZ_MFM_10MeasuresAndMean.tif');    
    };
retFileAll = {
    fullfile(folder, 'Bacteria1_DoubleLobes_MFM_10MeasuresAndMean_tiled.mat');
    fullfile(folder, 'Bacteria2_LongZ_MFM_10MeasuresAndMean_tiled.mat');    
    };
tagAll = {'Bacteria1_DoubleLobes_MFM_10MeasuresAndMean'; 
           'Bacteria2_LongZ_MFM_10MeasuresAndMean'};
cam = CAMERA('EMGain', 300, 'camOffsetFile', '/sandbox/Dropbox/smallWorlds/20170314_Camera/camOffset.tif');
pages = [];
NBac = numel(bacFileAll);
for nBac = 1:NBac    
    gOrigUint16 = tif.read(bacFileAll{nBac});
    tag = tagAll{nBac};
    [g, gTilePhoton, gPlusBg] = preprocess.cleanBackgroundUseTiles(gOrigUint16, tiles, cam, pages, folder, tag);
    save(retFileAll{nBac}, 'readme', 'g', 'gTilePhoton', 'tiles', 'cam', 'pages');
end
