function cm = getColormap(cmName, N)
%generate an array of N*3 that is can be used for colormp
% in difference image, may generate an array of N*3 if N is odd, or (N+1)*3 if N is even, i.e. size (floor(N/2)*2+1) * 3 

if ~exist('N', 'var') || isempty(N)
    N = 256;
end
%   2017.11.16_Xiang
switch lower(cmName)
    case {'gray', 'grey', 'jet'}
        h=figure(1e6);cm = feval(lower(cmName), N);close(h);
    case lower('jetTimesGray')
        h=figure(1e6);cm = jet(N).*gray(N);close(h);
    case lower('jetWithBlackBackground')
        h=figure(1e6);cm = jet(N);close(h);
        cm(1,:) = [0,0,0];
        %cm(1,:) = 
    case lower('jetWithWhiteBackground')
        h=figure(1e6);cm = jet(N);close(h);
        cm(1,:) = [1,1,1];        
    case lower('jetWith90WhiteBackground')
        cm = jet(N);
        cm(1,:) = [1,1,1]*0.9;
    case lower('jetWith95WhiteBackground')
        cm = jet(N);
        cm(1,:) = [1,1,1]*0.95;        
    case  lower('BlueBlackRed')
        NHalf = floor(N/2); gap = 1/NHalf;
        cmBlue2Neutral = (1:-gap:0)' * [0, 0, 1];
        cmNeutral2Red  = (0:gap:1)'  * [1, 0, 0];
        cm = [cmBlue2Neutral(1:end-1,:); cmNeutral2Red]; % end-1 to merge the duplicates between the two sub-colorbars 
    case  lower('BlueWhiteRed')
        NHalf = floor(N/2); gap = 1/NHalf;
        cmBlue2Neutral = (1:-gap:0)' * [0, 0, 1]  +  (0:gap:1)'  * [1, 1, 1];
        cmNeutral2Red  = (0:gap:1)'  * [1, 0, 0]  +  (1:-gap:0)' * [1, 1, 1];
        cm = [cmBlue2Neutral(1:end-1,:); cmNeutral2Red]; % end-1 to merge the duplicates between the two sub-colorbars 
    case  lower('Blue90WhiteRed')
        NHalf = floor(N/2); gap = 1/NHalf;
        cmBlue2Neutral = (1:-gap:0)' * [0, 0, 1]  +  (0:gap:1)'  * [1, 1, 1]*0.9;
        cmNeutral2Red  = (0:gap:1)'  * [1, 0, 0]  +  (1:-gap:0)' * [1, 1, 1]*0.9;
        cm = [cmBlue2Neutral(1:end-1,:); cmNeutral2Red]; % end-1 to merge the duplicates between the two sub-colorbars 
    case  lower('Blue95WhiteRed')
        NHalf = floor(N/2); gap = 1/NHalf;
        cmBlue2Neutral = (1:-gap:0)' * [0, 0, 1]  +  (0:gap:1)'  * [1, 1, 1]*0.95;
        cmNeutral2Red  = (0:gap:1)'  * [1, 0, 0]  +  (1:-gap:0)' * [1, 1, 1]*0.95;
        cm = [cmBlue2Neutral(1:end-1,:); cmNeutral2Red]; % end-1 to merge the duplicates between the two sub-colorbars 
    otherwise
        %case   lower({'mNeonGreen', 'mWasabi'})
        cm = mNeonGreen(cmName, N);        
end

end

