%%  central line
AMatrix = [1 0];
b = 1;
tau = 1e-10;
%t = 10.^(-20:20);
tAll = 10.^(-5:5);
%tAll = 10.^(15:15);
tAll = 10.^(0:15);
xCt = [(1-tau+sqrt((1-tau)^2+4./tAll))/2;
    1/tau*1./tAll];
figure(1); clf;
subplot(121); plot(xCt(1,:), xCt(2,:)); grid on; xlabel('x1'); ylabel('x2');   legend(sprintf('central path for t from %.2e to %.2e:', tAll(1), tAll(end)));
subplot(122); loglog(xCt(1,:), xCt(2,:)); grid on; xlabel('x1'); ylabel('x2'); legend(sprintf('central path for t from %.2e to %.2e:', tAll(1), tAll(end)));
%jx = 0.5* bsxfun(@minus, A*xCt, b)

% newton steps
subplot(121); hold on;
epsilon = eps;
%x0 = [5; epsilon];
x0 = [epsilon; 5];
x0 = [100; 100];
%t = tAll(1);
t = tAll(1);
%t = tAll(end);
xNt = x0;
x = x0;
for k = 1:100
    dx = [x(1) * (1 + (1-tau-x(1))*t*x(1)) / (1 + t*x(1)^2);
         x(2) * (1 - tau*t*x(2))];
    x = x+dx;
    xNt = [xNt x];
end

plot(xNt(1,:), xNt(2,:), 'x-r');
legend({sprintf('central path for t from %.2e to %.2e:', tAll(1), tAll(end)); sprintf('new ton step towards t = %.2e', t)});
plot(xCt(1,end), xCt(2,end'), 'oc');
plot(xNt(1,end), xNt(2,end), 'or');

curAxis = axis;
axis(curAxis +  [(curAxis(2)-curAxis(1))*[-0.1, 0.1]   (curAxis(4)-curAxis(3))*[-0.1, 0.1]])

%

%%
jx = 0.5* (AMatrix*xCt - b).^2 + tau*[1 1]*xCt - sum(log(xCt), 1)./tAll;
hx = 0.5* (AMatrix*xCt - b).^2 + tau*[1 1]*xCt;
figure(2); clf;
subplot(121); n=25; plot(n:numel(jx), jx(n:end), 'x-');  hold on; plot(numel(jx), jx(end), 'or'); grid on; xlim([0, 35])
%subplot(122); plot(hx, 'x-');  hold on; plot(numel(hx), hx(end), 'or'); grid on;
subplot(122); semilogy(hx, 'x-');  hold on; plot(numel(hx), hx(end), 'or'); grid on;


%%
function Jxt = JFun(x, t, A, b, tau)
% x is nDim * nSample matrix
% currently assume b = 1 scalar
    Jxt = 0.5* (A*x - b).^2 + tau*[1 1]*x - sum(log(x), 1)./t;
end