function cm = mNeonGreen(fluorophore, N)
%generate an array of N*3 that is can be used for colormp

if ~exist('N', 'var') || isempty(N)
    N = 64;
end

if (~exist('fluorophore','var') || isempty(fluorophore) )
    fluorophore='mNeonGreen';
end

flc = lower(fluorophore);

if (strcmp(flc,lower('mNeonGreen'))==1)
    % H=0.2, S=0.7 for V<0.75
    % H=0.2, S=0.7*(1-V)/0.25 for V>0.75
    V=(0:N-1)'/(N-1);
    H=0.2*ones(size(V));
    S1=0.7*ones(size(V));
    S2=0.7*(1-V)/0.25;
    S=min(S1,S2);
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('green'))==1)
    cm=(0:N)'./N*[0.0 1.0 0.0];
elseif (strcmp(flc,lower('FusionRed'))==1)
    V=(0:N-1)'/(N-1);
    H=zeros(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);

elseif (strcmp(flc,lower('mOrange2'))==1)
    V=(0:N-1)'/(N-1);
    H=0.1667*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('mApple'))==1)
    V=(0:N-1)'/(N-1);
    H=0.9954*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('mTFP1'))==1)
    V=(0:N-1)'/(N-1);
    H=0.5000*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('mWasabi'))==1)
    V=(0:N-1)'/(N-1);
    H=0.3333*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('mRuby'))==1)
    V=(0:N-1)'/(N-1);
    H=0.9984*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('TagRFP'))==1)
    V=(0:N-1)'/(N-1);
    H=0.0811*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('TagBFP'))==1)
    V=(0:N-1)'/(N-1);
    H=0.6027*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('TagRFP-T'))==1)
    V=(0:N-1)'/(N-1);
    H=0.1684*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('mKO2'))==1)
    V=(0:N-1)'/(N-1);
    H=0.1324*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('mWasabi2'))==1)
    V=(0:N-1)'/(N-1);
    H=0.3481*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('mCherry'))==1)
    V=(0:N-1)'/(N-1);
    H=0.9939*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
elseif (strcmp(flc,lower('mTFP1'))==1)
    V=(0:N-1)'/(N-1);
    H=0.5000*ones(size(V));
    S=ones(size(V));
    cm = hsv2rgb([H, S, V]);
else
    % default
    cm=(0:N)'./N*[0.0 1.0 0.0];
end


