function [x, objs, cpuTimes, SNRs, sampledHist, regFunVals, duals, ts, itersCG] = solveIPPDGond(varargin)
%Wrapper for Primal dual interior point method of Gondizo: 2014_Fountoulakis, Gondzio_Matrix-free Interior Point Method for Compressed Sensing Problems
%function [x, objFunVals, cpuTimes, SNRs] = solveIPPDFeasible(b, A, regWt, varargin)
% 2018.02.05_created after simplified  solveIPPDFeasible()

%% Parse Inputs
opts =  solver.parseInput(varargin{:});
cellfun(@(x) evalin('caller', sprintf('%s=opts.%s;', x, x)), fields(opts)); % exact each field as individual varibles

%%% ippd only parameters, we may just use the default of GOND
optsIPPD = [];
%%% ippd only parameters
optsIPPD.tol       = tolA;%1.0e-10;
optsIPPD.tolpcg    = 1.0e-2; % not sure how to parse
optsIPPD.maxiters = maxIterA;
optsIPPD.mxiterpcg = 100; %default 400
optsIPPD.maxstepsz = 0.999;
optsIPPD.verbose = 2; % 2 to output each iteration result

% Call the Matrix-free IPM solver.
b = b(:);
[x, out, objs, cpuTimes, SNRs, regFunVals, itersCG] = mfipm_NonNeg_XH(prod(xSz), A, b, regWt, optsIPPD, xGT(:));

%objs = 0.5*norm(b-A*x)^2 + regWt*sum(abs(x));
%cpuTimes = out.totcputime;
%SNRs = [];
sampledHist = [];
%regFunVals = regWt*sum(abs(x));
duals = [];
ts = [];
%itersCG = [];

x = reshape(x, xSz);
%  Output
%  ------
%
%    x:               The reconstructed sparse representation.
%    out.totcputime:  Total CPU time required by the Matrix-free IPM.
%    out.iters:       Number of Matrix-free IPM iterations.
%    out.cpusteps:    CPU time used for the calculation of the stepsizes.
%    out.totpcgiters: Total number of PCG iterations.
%    out.nMat:        Number of matrix-vector products.
%    out.predictors:  Number of predictor directions.
%    out.correctors:  Number of corrector directions.
%    out.linsystems:  Total number of linear systems solved. It is equal
%                     to out.predictors + out.correctors.
%    out.status:      1 if the problem was solved successfully, 0 if 
%                     maximum number of iterations reached.
%    out.message:     Termination status of the Matrix-free IPM
%                     solver. One of the following two messages is returned:
%                     i)  'Converged'
%                     ii) 'Maximum iterations reached'
