%https://www.mathworks.com/matlabcentral/answers/91024-gpu-fft2-discrepancies-different-from-cpu-based-fft2
% 2017.08.25_tested with NVIDIA NVS 310 GPU (<$100, 512MB) vs Intel Xeon CPU E5-1650 ($500~$600)
% 2017.08.25_ANL has Titan X (12GB, good for 38,000*38,000*8byte double precision), buy external power support
% https://www.amazon.com/gp/product/B00IKDETOC/ref=pe_2313350_224423710_em_1p_0_ti
%minumum version 352.63 for gpu computing
%nvidia-smi %shows everything, including power/memory use
% most time spend on transfer data

Ny = 1024;
Nx = Ny;
Nz = 200;

X = rand(Ny, Nx, Nz);
Ycpu = zeros(size(X), 'like', X);
Ygpu = zeros(size(X), 'like', X);
tic
nTest = 50;
for n = 1:nTest
    Ycpu(:,:,n) = fft2(X(:,:,n));    
end
toc


%%

tic
for n = 1:nTest
    Ygpu(:,:,n) = gather(fft2(gpuArray(X(:,:,n))));
end
toc
%% how much time spent on transfer data to and from gpu
tic
for n = 1:nTest
    t = gpuArray(X(:,:,n));
    t2 = gather(t);
end
toc

%% how much time spent on purely gpu computation
Xgpu = gpuArray(X(:,:,1));
tic
for n = 1:nTest*100
    t = fft2(Xgpu);   
end
toc
% Xgpu = gpuArray(X(:,:,nTest));
% tic
% for n = 1:nTest
%      = gather(fft2(Xgpu));
% end
% 
% toc



